#debuginfo not supported with Go
%global debug_package %{nil}
# modifying the Go binaries breaks the DWARF debugging
%global __os_install_post %{_rpmconfigdir}/brp-compress

%global gopath      %{_datadir}/gocode
%global import_path k8s.io/kubernetes

%global golang_version 1.15

%{!?commit:
# DO NOT MODIFY: the value on the line below is sed-like replaced by openshift/doozer
%global commit aa025a0305b18a04d3162f42992ca56e9bd94cda
}
%global shortcommit %(c=%{commit}; echo ${c:0:7})
# DO NOT MODIFY: the value on the line below is sed-like replaced by openshift/doozer
%{!?os_git_vars:
%global os_git_vars OS_GIT_VERSION=4.7.0-202111192046.p0.gaa025a0.assembly.stream-aa025a0 OS_GIT_MAJOR=4 OS_GIT_MINOR=7 OS_GIT_PATCH=0 OS_GIT_COMMIT=aa025a0305b18a04d3162f42992ca56e9bd94cda OS_GIT_TREE_STATE=clean KUBE_GIT_VERSION=v1.20.11+aa025a0 KUBE_GIT_MAJOR=1 KUBE_GIT_MINOR=20+ KUBE_GIT_COMMIT=f12ed970dad7592bafc187c70f6c2caa8fef8843 KUBE_GIT_TREE_STATE=clean
}

%if 0%{?skip_build}
%global do_build 0
%else
%global do_build 1
%endif
%if 0%{?skip_prep}
%global do_prep 0
%else
%global do_prep 1
%endif
%if 0%{?skip_dist}
%global package_dist %{nil}
%else
%global package_dist %{dist}
%endif

%{!?version: %global version 4.0.0}
%{!?release: %global release 1}

Name:           openshift
Version:        4.7.0
Release:        202111192046.p0.gaa025a0.assembly.stream%{?dist}
Summary:        Open Source Container Management by Red Hat
License:        ASL 2.0
URL:            https://%{import_path}

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:  x86_64 aarch64 ppc64le s390x
%endif

# TODO(marun) tar archives are no longer published for 4.x. Should this value be removed?
Source0:        openshift-4.7.0-202111192046.p0.gaa025a0.assembly.stream.tar.gz
BuildRequires:  systemd
BuildRequires:  bsdtar
BuildRequires:  golang >= %{golang_version}
BuildRequires:  krb5-devel
BuildRequires:  rsync

%description
[Maintainer] product: OpenShift Container Platform
OpenShift is a distribution of Kubernetes optimized for enterprise application
development and deployment. OpenShift adds developer and operational centric
tools on top of Kubernetes to enable rapid application development, easy
deployment and scaling, and long-term lifecycle maintenance for small and large
teams and applications. It provides a secure and multi-tenant configuration for
Kubernetes allowing you to safely host many different applications and workloads
on a unified cluster.

%package hyperkube
Summary:        OpenShift Kubernetes server commands
Requires:       util-linux
Requires:       socat
Requires:       iptables
Provides:       hyperkube = %{version}
Obsoletes:      atomic-openshift-hyperkube <= %{version}
Obsoletes:      atomic-openshift-node <= %{version}

%description hyperkube
[Maintainer] product: OpenShift Container Platform
%{summary}

%prep
%if 0%{do_prep}
%setup -q -n openshift-4.7.0
%endif

%build
%if 0%{do_build}
# Create Binaries only for building arch
%ifarch x86_64
  BUILD_PLATFORM="linux/amd64"
%endif
%ifarch ppc64le
  BUILD_PLATFORM="linux/ppc64le"
%endif
%ifarch %{arm} aarch64
  BUILD_PLATFORM="linux/arm64"
%endif
%ifarch s390x
  BUILD_PLATFORM="linux/s390x"
%endif
KUBE_BUILD_PLATFORMS="${BUILD_PLATFORM}" %{os_git_vars} make all WHAT='cmd/kube-apiserver cmd/kube-controller-manager cmd/kube-scheduler cmd/kubelet'
%endif

%install

PLATFORM="$(go env GOHOSTOS)/$(go env GOHOSTARCH)"
install -d %{buildroot}%{_bindir}

# Install linux components
for bin in kube-apiserver kube-controller-manager kube-scheduler kubelet
do
  echo "+++ INSTALLING ${bin}"
  install -p -m 755 _output/local/bin/${PLATFORM}/${bin} %{buildroot}%{_bindir}/${bin}
done

install -p -m 755 openshift-hack/images/hyperkube/hyperkube %{buildroot}%{_bindir}/hyperkube

%files hyperkube
%license LICENSE
%{_bindir}/hyperkube
%{_bindir}/kube-apiserver
%{_bindir}/kube-controller-manager
%{_bindir}/kube-scheduler
%{_bindir}/kubelet
%defattr(-,root,root,0700)

%changelog
